{This program needs Borland Pascal 7.1 to compile}
uses Graph,Crt,WinDos,DateTime;

const VGAPath='d:\TP7\EGAVGA.BGI';
      FontPath='d:\TP7\SANS.CHR';
      MaxX=639;
      MaxY=479;
 st:array [1..12] of string[4]=(
 'I',  'II',  'III',  'IV',  'V',  'VI',
 'VII',  'VIII',  'IX',  'X',  'XI',  'XII');
 Padding=15;
 CenterRad=6;
var Driver, Mode, Font1: integer;
    DriverF,FontF: file;
    DriverP,FontP,RocketP: pointer;
    h,m,s,h0,m0,s0,s100,RocketSize:word;
    Rad,Cx,Cy,Rx,Ry,Inc_Y:integer;

procedure CloseAll;
begin
 FreeMem(RocketP, SizeOf(RocketSize));
 FreeMem(FontP, FileSize(FontF));
 Close (FontF);
 FreeMem(DriverP, FileSize(DriverF));
 Close (DriverF);
 CloseGraph;
end;

procedure GraphError;
begin
 CloseAll;
 Writeln('Graphics error:', GraphErrorMsg(GraphResult));
 Writeln('Press ENTER...');
 Readln;
 Halt (GraphResult);
end;

procedure InitAll;
begin
 Assign(DriverF, VGAPath);
 Reset(DriverF, 1);
 GetMem(DriverP, FileSize(DriverF));
 BlockRead(DriverF, DriverP^, FileSIze(DriverF));
 if RegisterBGIdriver(DriverP)<0 then GraphError;
 Driver:=VGA; Mode:=VGAHi;
 InitGraph(Driver, Mode,'');
 if GraphResult < 0 then GraphError;
 Assign(FontF, FontPath);
 Reset(FontF, 1);
 GetMem(FontP, FileSize(FontF));
 BlockRead(FontF, FontP^, FileSize(FontF));
 Font1:=RegisterBGIfont(FontP);
 if Font1 < 0 then GraphError;
end;

procedure ClearScreen;
begin
 setfillstyle (SolidFill,White);
 bar (0,0,MaxX,MaxY);
end;

function GrToRad (g:integer):real;
begin
 if g>360 then g:=g mod 360;
 GrToRad:=g*Pi/180;
end;

procedure Clock;
var i,x,y:integer;
    Angle:real;
begin
 setcolor (Red);
 Rad:=MaxY div 3 - 2;
 Cx:=MaxX div 3;
 Cy:=MaxY div 3;
 setfillstyle (SolidFill,DarkGray);
 FillEllipse (Cx +2, Cy +2, Rad, Rad);
 setfillstyle (SolidFill,LightGray);
 Ellipse (Cx, Cy, 0, 360, Rad, Rad);
 FillEllipse (Cx, Cy, Rad, Rad);
 settextjustify (CenterText, CenterText);
 for i:=1 to 12 do begin
  Angle:=GrToRad(60-(i-4)*30);
  x:=Cx+Round((Rad-Padding)*sin(Angle));
  y:=Cy+Round((Rad-Padding)*cos(Angle));
  setcolor (DarkGray);
  outtextxy (x+2,y+2,st[i]);
  setcolor (LightGreen);
  outtextxy (x,y,st[i]);
 end;
 setfillstyle (SolidFill,White);
 setcolor (White);
 FillEllipse (Cx, Cy, CenterRad, CenterRad);
end;

procedure Arrow1 (a1,coef:integer);
var Angle:real;
    x1,y1,x2,y2:integer;
begin
 Angle:=GrToRad(a1);
 x1:=Cx+Round(CenterRad*sin(Angle));
 y1:=Cy+Round(CenterRad*cos(Angle));
 x2:=Cx+Round((Rad-coef*Padding)*sin(Angle));
 y2:=Cy+Round((Rad-coef*Padding)*cos(Angle));
 Line (x1,y1,x2,y2);
end;

function LeadingZero(w : Word) : String;
var s : String;
begin
 Str(w:0,s);
 if Length(s) = 1 then
   s := '0' + s;
 LeadingZero := s;
end;

procedure DrawTab;
begin
 setfillstyle (SolidFill,LightGray);
 bar (Cx-50,Cy+170,Cx+50,Cy+195);
 setcolor (Red);
 outtextxy (Cx,Cy+180,LeadingZero(h)+':'+LeadingZero(m)+':'+LeadingZero(s));
end;

function LeapYear(y:word):boolean;
begin
 if ((y mod 4=0) and (y mod 100<>0)) or (y mod 400=0) then LeapYear:=true
 else LeapYear:=false;
end;

procedure Calend;
const days : array [1..7] of String[2] =
    ('','','','','','','');
      maxdays : array [1..12] of integer=(
      31,28,31,30,31,30,31,31,30,31,30,31);
      mon: array [1..12] of String[8] =
    ('', 'ࠫ', '', '५', '', '',
    '', '', '', '', '', '');
var y, m, d, dow, maxd : Word;
    i,j,x0,x1,y1:integer;
    s:string;
begin
 SetTextStyle (DefaultFont, HorizDir, 1);
 settextjustify (LeftText, CenterText);
 GetDate(y,m,d,dow);
 x1:=2*MaxX div 3;
 x0:=x1;
 y1:=Cy;
 for i:=1 to 7 do outtextxy (x1,cy+(i-1)*16,days[i]);
 if dow=0 then dow:=7;
 for i:=d downto 1 do begin
  if dow>1 then dec(dow)
  else dow:=7;
 end;
 x1:=x1+24;
 y1:=cy+(dow-1)*16;
 if (LeapYear(y)) and (m=2) then maxd:=29
 else maxd:=maxdays[m];
 for i:=1 to maxd do begin
  str (i:2,s);
  if i=d then setcolor(LightRed)
  else setcolor (Green);
  outtextxy (x1,y1,s);
  if dow<7 then begin
   inc(dow);
   inc(y1,16);
  end
  else begin
   dow:=1;
   inc (x1,24);
   y1:=cy;
  end;
 end;
 settextjustify (CenterText, CenterText);
 SetTextStyle (Font1, HorizDir, 1);
 str(y:4,s);
 x0:=(x1+x0) div 2;
 outtextxy (x0, cy+8*16,' '+s);
 outtextxy (x0, cy-32,mon[m]);
end;

procedure Day;
const days : array [0..6] of String[11] =
    ('ᥭ','쭨','୨',
     '।','⢥','⭨', '㡡');
  Size=15;
  Pad=5;
var y, m, d, dow : Word;
    i,x1:integer;
begin
 GetDate(y,m,d,dow);
 setcolor (Brown);
 outtextxy (Cx,Cy+210,days[dow]);
 x1:=Cx-(Size*7+Pad*6) div 2;
 for i:=1 to 7 do begin
  if (dow=0) and (i=7) or (dow>0) and (i=dow) then
   setfillstyle (SolidFill,Blue)
  else setfillstyle (SolidFill,LightGray);
  bar (x1+(i-1)*Size+(i-1)*Pad,Cy+230,x1+i*Size+(i-1)*Pad,Cy+240);
 end;
 Calend;
end;

procedure Rocket;
begin
 PutImage(rx-10, ry, RocketP^, NormalPut);
 if (ry<10) or (ry>350) then inc_y:=-inc_y;
 inc(ry,inc_y);
 GetImage(rx-10, ry, rx+10, ry+70, RocketP^);
 setcolor (Red);
 moveto (rx,ry);
 linerel (-10,10);
 linerel (0,60);
 linerel (20,0);
 linerel (0,-60);
 linerel (-10,-10);
 setcolor (Green);
 circle (rx,ry+20,8);
 circle (rx-2,ry+17,2);
 circle (rx+2,ry+17,2);
 arc (rx,ry+20,180,360,5);
end;

procedure DrawArrows;
begin
 GetTime (h,m,s,s100);
 if s<>s0 then begin
  Rocket;
  DrawTab;

  if h<>h0 then Day;
  setcolor (LightGray);
  setlinestyle (SolidLn,0,ThickWidth);
  arrow1(60-(h0-4)*30-m0 div 2,5);
  arrow1(180-m0*6-s0 div 10,3);
  setlinestyle (DottedLn,0,NormWidth);
  arrow1(180-s0*6,2);
  setlinestyle (SolidLn,0,ThickWidth);
  setcolor (Yellow);
  arrow1(60-(h-4)*30-m div 2,5);
  setcolor (White);
  arrow1(180-m*6-s div 10,3);
  setlinestyle (DottedLn,0,NormWidth);
  arrow1(180-s*6,2);
  s0:=s;
  m0:=m;
  h0:=h;
 end;
end;

begin
 InitAll;
 ClearScreen;
 SetTextStyle (Font1, HorizDir, 1);
 Clock;
 h0:=25; m0:=25; s0:=25;
 rx:=396; ry:=286; Inc_Y:=-10;
 RocketSize := ImageSize(0, 0, 20, 70);
 GetMem(RocketP, RocketSize);
 GetImage(rx-10, ry, rx+10, ry+70, RocketP^);
 repeat
  DrawArrows;
 until keypressed;
 reset (input);
 CloseAll;
end.
